
<!DOCTYPE html>


<html lang="en" data-content_root="../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Post Training Quantization with AIDGE &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../_static/nbsphinx-code-cells.css?v=2aa19091" />
    <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script>window.MathJax = {"tex": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true}, "options": {"ignoreHtmlClass": "tex2jax_ignore|mathjax_ignore|document", "processHtmlClass": "tex2jax_process|mathjax_process|math|output_area"}}</script>
    <script defer="defer" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/Tutorial/ptq';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Aidge tiling demonstration" href="tiling.html" />
    <link rel="prev" title="Aidge ONNX tutorial" href="ONNX.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="101_first_step.html">Aidge demonstration</a></li>
</ul>
<ul class="nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="database.html">Database MNIST</a></li>
<li class="toctree-l1"><a class="reference internal" href="graph_matching.html">Graph matching and manipulation with Aidge</a></li>
<li class="toctree-l1"><a class="reference internal" href="scheduling.html">Understanding Aidge’s scheduling</a></li>
<li class="toctree-l1"><a class="reference internal" href="learning.html">Training a simple Neural Network</a></li>
<li class="toctree-l1"><a class="reference internal" href="ONNX.html">Aidge ONNX tutorial</a></li>
</ul>
<ul class="current nav bd-sidenav">
<li class="toctree-l1 current active"><a class="current reference internal" href="#">Post Training Quantization with AIDGE</a></li>
<li class="toctree-l1"><a class="reference internal" href="tiling.html">Aidge tiling demonstration</a></li>
</ul>
<ul class="nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="export_cpp.html">Export a MNIST model to a CPP standalone project</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">Tutorials</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Post Training Quantization with AIDGE</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="Post-Training-Quantization-with-AIDGE">
<h1>Post Training Quantization with AIDGE<a class="headerlink" href="#Post-Training-Quantization-with-AIDGE" title="Link to this heading">#</a></h1>
<section id="What-is-Network-Quantization-?">
<h2>What is Network Quantization ?<a class="headerlink" href="#What-is-Network-Quantization-?" title="Link to this heading">#</a></h2>
<p>Deploying large Neural Network architectures on embedded targets can be a difficult task as they often require billions of floating operations per inference.</p>
<p>To address this problem, several techniques have been developed over the past decades in order to reduce the computational load and energy consumption of those inferences. Those techniques include Pruning, Compression, Quantization and Distillation.</p>
<p>In particular, Post Training Quantization (PTQ) consists in taking an already trained network, and replacing the costly floating-point MADD by their integer counterparts. The use of Bytes instead of Floats also leads to a smaller memory bandwidth.</p>
<p>While this process can seem trivial, the naive approach consisting only in rounding the parameters and activations doesn’t work in practice. Instead, we want to normalize the network in order to optimize the ranges of parameters and values propagated inside the network, before applying quantization.</p>
</section>
<section id="The-Quantization-Pipeline">
<h2>The Quantization Pipeline<a class="headerlink" href="#The-Quantization-Pipeline" title="Link to this heading">#</a></h2>
<p>The PTQ algorithm consists in a 3 steps pipeline:</p>
<ul class="simple">
<li><p>First we optimize the parameter ranges by propagating the scaling coefficients in the network.</p></li>
<li><p>Secondly, we compute the activation values over an input dataset, and insert the scaling nodes.</p></li>
<li><p>Finally, we quantize the network by reconfiguring the scaling nodes according to the desired precision.</p></li>
</ul>
<p><img alt="alt text" src="../../_images/ptq_diagram.png" /></p>
</section>
<section id="Doing-the-PTQ-with-AIDGE">
<h2>Doing the PTQ with AIDGE<a class="headerlink" href="#Doing-the-PTQ-with-AIDGE" title="Link to this heading">#</a></h2>
<p>This notebook shows how to perform PTQ of a Convolutional Network, trained on the MNIST dataset.</p>
<p>The tutorial is constructed as follows :</p>
<ul class="simple">
<li><p>Setup of the AIDGE environment</p></li>
<li><p>Loading of the model and example inferences</p></li>
<li><p>Evaluation of the trained model accuracy</p></li>
<li><p>Post Training Quantization and test inferences</p></li>
<li><p>Evaluation of the quantized model accuracy</p></li>
</ul>
<p>As we will observe in this notebook, we get zero degradation of the accuracy for a 8-bits PTQ.</p>
<p>Let’s begin !</p>
<section id="(if-needed)-Download-the-model">
<h3>(if needed) Download the model<a class="headerlink" href="#(if-needed)-Download-the-model" title="Link to this heading">#</a></h3>
<p>If you don’t have git-lfs, you can download the model and data using this piece of code</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">os</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">requests</span>

<span class="k">def</span><span class="w"> </span><span class="nf">download_material</span><span class="p">(</span><span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">isfile</span><span class="p">(</span><span class="n">path</span><span class="p">):</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;https://gitlab.eclipse.org/eclipse/aidge/aidge/-/raw/dev/examples/tutorials/PTQ_tutorial/&quot;</span><span class="o">+</span><span class="n">path</span><span class="o">+</span><span class="s2">&quot;?ref_type=heads&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">==</span> <span class="mi">200</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">response</span><span class="o">.</span><span class="n">content</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;File downloaded successfully.&quot;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Failed to download file. Status code:&quot;</span><span class="p">,</span> <span class="n">response</span><span class="o">.</span><span class="n">status_code</span><span class="p">)</span>

<span class="c1"># Download onnx model file</span>
<span class="n">download_material</span><span class="p">(</span><span class="s2">&quot;ConvNet.onnx&quot;</span><span class="p">)</span>
<span class="c1"># Download data sample</span>
<span class="n">download_material</span><span class="p">(</span><span class="s2">&quot;mnist_samples.npy.gz&quot;</span><span class="p">)</span>
<span class="c1"># Download data label</span>
<span class="n">download_material</span><span class="p">(</span><span class="s2">&quot;mnist_labels.npy.gz&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
File downloaded successfully.
File downloaded successfully.
File downloaded successfully.
</pre></div></div>
</div>
</section>
</section>
<section id="Environment-setup-...">
<h2>Environment setup …<a class="headerlink" href="#Environment-setup-..." title="Link to this heading">#</a></h2>
<p>We need numpy for manipulating the inputs, matplotlib for visualization purposes, and gzip to uncompress the numpy dataset.</p>
<p>Then we want to import the aidge modules :</p>
<ul class="simple">
<li><p>the core module contains everything we need to manipulate the graph.</p></li>
<li><p>the backend module allows us to perform inferences using the CPU.</p></li>
<li><p>the onnx module allows us to load the pretrained model (stored in an onnx file).</p></li>
<li><p>the quantization module encaplsulate the Post Training Quantization algorithm.</p></li>
</ul>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">gzip</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">numpy</span><span class="w"> </span><span class="k">as</span><span class="w"> </span><span class="nn">np</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">matplotlib.pyplot</span><span class="w"> </span><span class="k">as</span><span class="w"> </span><span class="nn">plt</span>

<span class="kn">import</span><span class="w"> </span><span class="nn">aidge_core</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">aidge_onnx</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">aidge_backend_cpu</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">aidge_quantization</span>

<span class="nb">print</span><span class="p">(</span><span class="s2">&quot; Available backends : &quot;</span><span class="p">,</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">Tensor</span><span class="o">.</span><span class="n">get_available_backends</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
 Available backends :  {&#39;cpu&#39;}
</pre></div></div>
</div>
<p>Then, let’s define the configurations of this script …</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">NB_SAMPLES</span>  <span class="o">=</span> <span class="mi">100</span>
<span class="n">NB_BITS</span>     <span class="o">=</span> <span class="mi">8</span>
</pre></div>
</div>
</div>
<p>Now, let’s load and visualize some samples …</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">samples</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">gzip</span><span class="o">.</span><span class="n">GzipFile</span><span class="p">(</span><span class="s1">&#39;mnist_samples.npy.gz&#39;</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">))</span>
<span class="n">labels</span>  <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">gzip</span><span class="o">.</span><span class="n">GzipFile</span><span class="p">(</span><span class="s1">&#39;mnist_labels.npy.gz&#39;</span><span class="p">,</span>  <span class="s2">&quot;r&quot;</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">subplot</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;off&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">tight_layout</span><span class="p">()</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">imshow</span><span class="p">(</span><span class="n">samples</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">cmap</span><span class="o">=</span><span class="s1">&#39;gray&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/source_Tutorial_ptq_9_0.png" src="../../_images/source_Tutorial_ptq_9_0.png" />
</div>
</div>
</section>
<section id="Importing-the-model-in-AIDGE-...">
<h2>Importing the model in AIDGE …<a class="headerlink" href="#Importing-the-model-in-AIDGE-..." title="Link to this heading">#</a></h2>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">aidge_model</span> <span class="o">=</span> <span class="n">aidge_onnx</span><span class="o">.</span><span class="n">load_onnx</span><span class="p">(</span><span class="s2">&quot;ConvNet.onnx&quot;</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="n">aidge_core</span><span class="o">.</span><span class="n">remove_flatten</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">)</span> <span class="c1"># we want to get rid of the &#39;flatten&#39; nodes ...</span>
</pre></div>
</div>
</div>
</section>
<section id="Setting-up-the-AIDGE-scheduler-...">
<h2>Setting up the AIDGE scheduler …<a class="headerlink" href="#Setting-up-the-AIDGE-scheduler-..." title="Link to this heading">#</a></h2>
<p>In order to perform inferences with AIDGE we need to setup a scheduler. But before doing so, we need to create a data producer node and connect it to the network.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Insert the input producer</span>
<span class="n">input_node</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">Producer</span><span class="p">([</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">28</span><span class="p">],</span> <span class="s2">&quot;XXX&quot;</span><span class="p">)</span>
<span class="n">input_node</span><span class="o">.</span><span class="n">add_child</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">)</span>
<span class="n">aidge_model</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">input_node</span><span class="p">)</span>

<span class="c1"># Set up the backend</span>
<span class="n">aidge_model</span><span class="o">.</span><span class="n">set_datatype</span><span class="p">(</span><span class="n">aidge_core</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
<span class="n">aidge_model</span><span class="o">.</span><span class="n">set_backend</span><span class="p">(</span><span class="s2">&quot;cpu&quot;</span><span class="p">)</span>

<span class="c1"># Create the Scheduler</span>
<span class="n">scheduler</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">SequentialScheduler</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">)</span>
</pre></div>
</div>
</div>
</section>
<section id="Running-some-example-inferences-...">
<h2>Running some example inferences …<a class="headerlink" href="#Running-some-example-inferences-..." title="Link to this heading">#</a></h2>
<p>Now that the scheduler is ready, let’s perform some inferences. To do so we first declare a utility function that will prepare and set our inputs, propagate them and retreive the outputs.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="k">def</span><span class="w"> </span><span class="nf">propagate</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">scheduler</span><span class="p">,</span> <span class="n">sample</span><span class="p">):</span>
    <span class="c1"># Setup the input</span>
    <span class="n">sample</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">sample</span><span class="p">,</span> <span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">28</span><span class="p">))</span>
    <span class="n">input_tensor</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">Tensor</span><span class="p">(</span><span class="n">sample</span><span class="p">)</span>
    <span class="n">input_node</span><span class="o">.</span><span class="n">get_operator</span><span class="p">()</span><span class="o">.</span><span class="n">set_output</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">input_tensor</span><span class="p">)</span>
    <span class="c1"># Run the inference</span>
    <span class="n">scheduler</span><span class="o">.</span><span class="n">forward</span><span class="p">()</span>
    <span class="c1"># Gather the results</span>
    <span class="n">output_node</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">get_output_nodes</span><span class="p">()</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
    <span class="n">output_tensor</span> <span class="o">=</span> <span class="n">output_node</span><span class="o">.</span><span class="n">get_operator</span><span class="p">()</span><span class="o">.</span><span class="n">get_output</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">output_tensor</span><span class="p">)</span>

<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1"> EXAMPLE INFERENCES :&#39;</span><span class="p">)</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
    <span class="n">output_array</span> <span class="o">=</span> <span class="n">propagate</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">,</span> <span class="n">scheduler</span><span class="p">,</span> <span class="n">samples</span><span class="p">[</span><span class="n">i</span><span class="p">])</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">labels</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="p">,</span> <span class="s1">&#39; -&gt; &#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">round</span><span class="p">(</span><span class="n">output_array</span><span class="p">,</span> <span class="mi">2</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>

 EXAMPLE INFERENCES :
7  -&gt;  [[-0.02  0.   -0.03  0.03  0.03  0.01 -0.    0.94  0.02 -0.03]]
2  -&gt;  [[ 0.17  0.01  0.8  -0.03  0.01 -0.04  0.06 -0.01 -0.05  0.  ]]
1  -&gt;  [[-0.    0.99  0.02  0.02 -0.02 -0.    0.03 -0.01  0.01 -0.04]]
0  -&gt;  [[ 0.97  0.03 -0.02  0.01 -0.01  0.04  0.03  0.02  0.01 -0.07]]
4  -&gt;  [[-0.05 -0.   -0.01 -0.02  1.13 -0.01 -0.01 -0.03  0.04 -0.01]]
1  -&gt;  [[-0.01  1.06 -0.   -0.02 -0.01  0.02 -0.02  0.02  0.01 -0.01]]
4  -&gt;  [[-0.03 -0.04  0.01 -0.01  0.94  0.01  0.04  0.03  0.19 -0.12]]
9  -&gt;  [[-0.02  0.02  0.07  0.09  0.12 -0.02 -0.02 -0.02  0.12  0.67]]
5  -&gt;  [[ 0.03 -0.03  0.04 -0.07  0.01  0.69  0.16  0.06  0.08 -0.02]]
9  -&gt;  [[ 0.01 -0.01 -0.   -0.03  0.05 -0.02  0.01  0.06 -0.01  0.95]]
</pre></div></div>
</div>
</section>
<section id="Computing-the-model-accuracy-...">
<h2>Computing the model accuracy …<a class="headerlink" href="#Computing-the-model-accuracy-..." title="Link to this heading">#</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="k">def</span><span class="w"> </span><span class="nf">compute_accuracy</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">samples</span><span class="p">,</span> <span class="n">labels</span><span class="p">):</span>
    <span class="n">acc</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">samples</span><span class="p">):</span>
        <span class="n">y</span> <span class="o">=</span> <span class="n">propagate</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">scheduler</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">labels</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">==</span> <span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">y</span><span class="p">):</span>
            <span class="n">acc</span> <span class="o">+=</span> <span class="mi">1</span>
    <span class="k">return</span> <span class="n">acc</span> <span class="o">/</span> <span class="nb">len</span><span class="p">(</span><span class="n">samples</span><span class="p">)</span>

<span class="n">accuracy</span> <span class="o">=</span> <span class="n">compute_accuracy</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">,</span> <span class="n">samples</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="n">NB_SAMPLES</span><span class="p">],</span> <span class="n">labels</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1"> MODEL ACCURACY : </span><span class="si">{</span><span class="n">accuracy</span><span class="w"> </span><span class="o">*</span><span class="w"> </span><span class="mi">100</span><span class="si">:</span><span class="s1">.3f</span><span class="si">}</span><span class="s1">%&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>

 MODEL ACCURACY : 100.000%
</pre></div></div>
</div>
</section>
<section id="Quantization-dataset-creation-...">
<h2>Quantization dataset creation …<a class="headerlink" href="#Quantization-dataset-creation-..." title="Link to this heading">#</a></h2>
<p>We need to convert a subset of our Numpy samples into AIDGE tensors, so that they can be used to compute the activation ranges.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">tensors</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">sample</span> <span class="ow">in</span> <span class="n">samples</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="n">NB_SAMPLES</span><span class="p">]:</span>
    <span class="n">sample</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">sample</span><span class="p">,</span> <span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">28</span><span class="p">))</span>
    <span class="n">tensor</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">Tensor</span><span class="p">(</span><span class="n">sample</span><span class="p">)</span>
    <span class="n">tensors</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tensor</span><span class="p">)</span>
</pre></div>
</div>
</div>
</section>
<section id="Applying-the-PTQ-to-the-model-...">
<h2>Applying the PTQ to the model …<a class="headerlink" href="#Applying-the-PTQ-to-the-model-..." title="Link to this heading">#</a></h2>
<p>Now that everything is ready, we can call the PTQ routine ! Note that after the quantization we need to update the scheduler.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">aidge_quantization</span><span class="o">.</span><span class="n">quantize_network</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">,</span> <span class="n">NB_BITS</span><span class="p">,</span> <span class="n">tensors</span><span class="p">)</span>

<span class="n">scheduler</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">SequentialScheduler</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">)</span>
</pre></div>
</div>
</div>
</section>
<section id="Running-some-quantized-inferences-...">
<h2>Running some quantized inferences …<a class="headerlink" href="#Running-some-quantized-inferences-..." title="Link to this heading">#</a></h2>
<p>Now that our network is quantized, what about testing some inferences ? Let’s do so, but before, we need not to forget that our 8-bit network expect 8-bit inputs ! We thus need to rescale the input tensors …</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">scaling</span> <span class="o">=</span> <span class="mi">2</span><span class="o">**</span><span class="p">(</span><span class="n">NB_BITS</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">NB_SAMPLES</span><span class="p">):</span>
    <span class="n">samples</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">round</span><span class="p">(</span><span class="n">samples</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">*</span> <span class="n">scaling</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>We can now perform our quantized inferences …</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="nb">print</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1"> EXAMPLE QUANTIZED INFERENCES :&#39;</span><span class="p">)</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
    <span class="n">input_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">samples</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">28</span><span class="p">))</span>
    <span class="n">output_array</span> <span class="o">=</span> <span class="n">propagate</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">,</span> <span class="n">scheduler</span><span class="p">,</span> <span class="n">input_array</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">labels</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="p">,</span> <span class="s1">&#39; -&gt; &#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">round</span><span class="p">(</span><span class="n">output_array</span><span class="p">,</span> <span class="mi">2</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>

 EXAMPLE QUANTIZED INFERENCES :
7  -&gt;  [[ -1.86   0.5   -3.07   3.28   2.93   1.1   -0.12 103.51   1.85  -2.92]]
2  -&gt;  [[ 1.872e+01  1.250e+00  8.744e+01 -3.360e+00  6.600e-01 -4.480e+00
   6.280e+00 -1.130e+00 -6.000e+00  6.000e-02]]
1  -&gt;  [[ -0.15 109.     2.27   1.93  -1.75  -0.39   3.53  -1.16   1.36  -4.48]]
0  -&gt;  [[106.18   3.42  -2.7    0.72  -0.62   4.9    2.75   1.91   0.92  -7.82]]
4  -&gt;  [[-5.7100e+00 -9.0000e-02 -9.7000e-01 -1.9100e+00  1.2401e+02 -9.6000e-01
  -1.3900e+00 -2.9600e+00  4.3000e+00 -1.0500e+00]]
1  -&gt;  [[ -0.57 116.28  -0.4   -2.17  -1.38   1.62  -2.5    1.66   1.49  -1.27]]
4  -&gt;  [[ -3.32  -4.14   0.61  -1.43 102.52   1.56   4.78   3.59  20.92 -12.72]]
9  -&gt;  [[-2.31  2.32  7.17  9.86 12.81 -2.33 -2.67 -1.89 13.38 73.47]]
5  -&gt;  [[ 3.16 -3.83  4.07 -8.06  1.2  76.01 18.02  6.82  8.64 -2.14]]
9  -&gt;  [[ 1.2800e+00 -6.7000e-01 -8.0000e-02 -3.4100e+00  4.9700e+00 -1.7700e+00
   1.4800e+00  6.6500e+00 -1.4700e+00  1.0455e+02]]
</pre></div></div>
</div>
<section id="Computing-the-quantized-accuracy-...">
<h3>Computing the quantized accuracy …<a class="headerlink" href="#Computing-the-quantized-accuracy-..." title="Link to this heading">#</a></h3>
<p>Just as we’ve done for the initial network, we can compute the quantized model accuracy …</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">accuracy</span> <span class="o">=</span> <span class="n">compute_accuracy</span><span class="p">(</span><span class="n">aidge_model</span><span class="p">,</span> <span class="n">samples</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="n">NB_SAMPLES</span><span class="p">],</span> <span class="n">labels</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1"> QUANTIZED MODEL ACCURACY : </span><span class="si">{</span><span class="n">accuracy</span><span class="w"> </span><span class="o">*</span><span class="w"> </span><span class="mi">100</span><span class="si">:</span><span class="s1">.3f</span><span class="si">}</span><span class="s1">%&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>

 QUANTIZED MODEL ACCURACY : 100.000%
</pre></div></div>
</div>
</section>
</section>
<section id="Work-is-done-!">
<h2>Work is done !<a class="headerlink" href="#Work-is-done-!" title="Link to this heading">#</a></h2>
<p>We see that a 8-bit PTQ does not affect the accuracy of our model ! This result shows that a proper quantization algorithm can be used to deploy a Neural Network on very small devices, where manipulating bytes is optimal. We encourage you to run this notebook again with even more aggressive quantization values !</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="nb">print</span><span class="p">(</span><span class="s1">&#39;That</span><span class="se">\&#39;</span><span class="s1">s all folks !&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
That&#39;s all folks !
</pre></div></div>
</div>
</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="ONNX.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Aidge ONNX tutorial</p>
      </div>
    </a>
    <a class="right-next"
       href="tiling.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Aidge tiling demonstration</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#What-is-Network-Quantization-?">What is Network Quantization ?</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#The-Quantization-Pipeline">The Quantization Pipeline</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Doing-the-PTQ-with-AIDGE">Doing the PTQ with AIDGE</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#(if-needed)-Download-the-model">(if needed) Download the model</a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Environment-setup-...">Environment setup …</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Importing-the-model-in-AIDGE-...">Importing the model in AIDGE …</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Setting-up-the-AIDGE-scheduler-...">Setting up the AIDGE scheduler …</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Running-some-example-inferences-...">Running some example inferences …</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Computing-the-model-accuracy-...">Computing the model accuracy …</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Quantization-dataset-creation-...">Quantization dataset creation …</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Applying-the-PTQ-to-the-model-...">Applying the PTQ to the model …</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Running-some-quantized-inferences-...">Running some quantized inferences …</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Computing-the-quantized-accuracy-...">Computing the quantized accuracy …</a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Work-is-done-!">Work is done !</a></li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/Tutorial/ptq.nblink">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../_sources/source/Tutorial/ptq.nblink.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>